/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-14 15:32:06 UTC)
 * on 2013-08-19 at 21:07:03 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.datastore.model;

/**
 * Model definition for CompositeFilter.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Cloud Datastore API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class CompositeFilter extends com.google.api.client.json.GenericJson {

  /**
   * The list of filters to combine. Must contain at least one filter.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Filter> filters;

  static {
    // hack to force ProGuard to consider Filter used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Filter.class);
  }

  /**
   * The operator for combining multiple filters. Only "and" is currently supported.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String operator;

  /**
   * The list of filters to combine. Must contain at least one filter.
   * @return value or {@code null} for none
   */
  public java.util.List<Filter> getFilters() {
    return filters;
  }

  /**
   * The list of filters to combine. Must contain at least one filter.
   * @param filters filters or {@code null} for none
   */
  public CompositeFilter setFilters(java.util.List<Filter> filters) {
    this.filters = filters;
    return this;
  }

  /**
   * The operator for combining multiple filters. Only "and" is currently supported.
   * @return value or {@code null} for none
   */
  public java.lang.String getOperator() {
    return operator;
  }

  /**
   * The operator for combining multiple filters. Only "and" is currently supported.
   * @param operator operator or {@code null} for none
   */
  public CompositeFilter setOperator(java.lang.String operator) {
    this.operator = operator;
    return this;
  }

  @Override
  public CompositeFilter set(String fieldName, Object value) {
    return (CompositeFilter) super.set(fieldName, value);
  }

  @Override
  public CompositeFilter clone() {
    return (CompositeFilter) super.clone();
  }

}
